Subject: Web99 - a new Search and Transfer Tool for your DiskImages/TiFiles - initial puplic release

From: [email-masked]
Date: 17 May 2015 10:12:17 -0700

Web99
=====

This program is freeware.
Copyright by Klaus Lukaschek

Program History
===============

2015-05-17 initial public release - Version 0.1

Introduction
============

The idea of this program is to help you in 3 different areas:
- get rid of duplicate Disk Images and Ti Files.
- make your Ti Files searchable, even from the TI-99
- access and manage your Ti File Collection from your TI-99 

This Tool is programmed in Visual C#, it's .NET Framework 4 Client Profile based and therefore runs on Windows XP or later Windows Versions.
It is compiled to run on both x64 and x86 platforms. You will need to have .NET Framework 4 or later, it is sufficient to only have the 'Runtime' installed.
The index and search technology that got integrated into the project is the .NET port of Lucene. A serial port (or any USB2Serial solution) is required only if you want to communicate with your TI-99 or if you want to use the Search from your TI-99. 

Why?
====
Whenever I am on a TI meeting or hitting a new website, it seems that I get tons of disk images, that I manually have to compare against my current collection.
I got tired of doing this over and over again. There must be an automatic way to check the new files for their uniqueness.

Imagine, having to find a certain Ti File - mostly a program - in your collection. How do you know on which Disk Image and in which Path it is stored?
The problem is, a Windows search tool can't look into your Disk Images and gives you a list of Ti Files with the name "ROS". Maybe you would even know the size in sectors, its Filetype, the Ti Diskname or some other Meta Data. However for your Pc your disk image is simply a Pc file with a Pc filename, a Pc filesize and some Date Information. Until now, most people started Ti99Dir or TiImageTool and opened one Disk Image after another until they hit the Ti File. How much cooler would it be if you have something like Google, customized for your TI-99 Disk Images? What if Google would know exactly all TI relevant information about your Disks, and it would let you search by Ti Filename, by Ti Diskname, by Ti Filetype, Size and more. Well, Web99 is trying to become exactly that search engine for you. It is even trying to become such a search engine usable from your TI machine.

Uniqueness
==========

For each stream of data you can calculate a Hashkey. I am using the MD5 128bit algorithm to generate those. This means the result is a 128bit length Key, usually this is written in hexadecimal form and therefore such a key looks like '88ec1168efbd75617d28fa3ade124dfa'. For our purpose this lenght should be more than enough to ensure uniqueness. Based on the same input, the same Hashkey is produced. So if you have two files, calculate their Hashkey and they are different means that those files are not identical. So comparing becomes a lot easier, we simply need to calculate Hashkeys once for everything and compare those with each other. The dupes will show up immediately because they have the same Hashkey.

The check for uniqueness can be done on all kind of levels. 

So I started the idea to calculate an unique identifier for each Disk Image and every Ti File on my Pc, based on their binary content and meta data.
A program would be able to calculate these for a new set of Files and compare each against your collection.

Thanks goes to
==============

Ciro Barile
Ermanno Betori
Mike Brent
Berry Harmsen
Jens-Eike Hartwig
Fred Kaal
Bernhard Laboranowitsch
Sandra Strommer
Gerhard Wiesinger
Mike Wright
OX. [Atariage]